<control-ad-photos style="display:block; position:relative">

	<div class="row mrg-bottom-sm">
		<div class="col-md-8">
			<p><strong>Επιλογή φωτογραφιών</strong> (έως { state.max_image_limit } φωτογραφίες)</p>
		</div>
		<div class="col-md-4 text-right">
			<a href="#" class="btn btn-default btn-sm { upload.files_max > 0 ? 'disabled' : ''}" onclick="{ new_image }"><i class="fa fa-plus"></i> Προσθήκη</a>
		</div>
	</div>
	
	<div class="upload-images" id="ad-photos">
		<div class="image-item" each="{ image, index in state.images }" if="{ image.deleted == 0 }" data-index="{ index }">
			<div class="title">
				{ index + 1 }
				<a href="#" class="remove" title="Διαγραφή φωτογραφίας" onclick="{ delete_image }"></a>
			</div>
			<div class="image">
				<img src="/image/xsthumb/img/{ image.path }/{ image.media }">
			</div>
		</div>
	</div>
	
	<p class="form-notification">Προσοχή! Η πρώτη φωτογραφία επιλέγεται ως φωτογραφία προφίλ.</p>

	<div class="upload-progress" if="{ upload.files_max > 0 }">
		<div class="upload-progress-content">
			Μεταφόρτωση εικόνας { upload.file_index + 1 } από { upload.files_max }
			<div class="progress">
				<div class="progress-bar" role="progressbar" style="width: { upload.progress }%;">
					{ upload.progress }%
				</div>
			</div>
		</div>
	</div>

	<loader-icon class="control-loader" if="{ state.loading }"></loader-icon>

	<!-- image upload form -->
    <form method="post" name='imageUploadForm' id='imageUploadForm' enctype="multipart/form-data">
        <input id="imageUploadInput" type="file" name="image[]" multiple style="display:none">
    </form>

	<script>
	/*
		Methods:
		initialize( [ max_image_limit ] ) :: initalize the control
		set_images( images array )
		get_images()

		Events:
		onchangehandler()
	*/

		this.state = {
			images: [],
			max_image_limit: 8, //this.opts.maximages || 8,
			loading: false,
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}


		this.initialize = max_image_limit => {
			if (typeof max_image_limit !== 'undefined') {
				this.state.max_image_limit = max_image_limit;
			}

			this.state.images = [];
			this.update();
			this.reset_upload();
		}


		this.set_images = images => {
			this.state.images = images;
			this.init_images();
			this.update();
		}


		this.get_images = () => {
			return this.state.images;
		}


		// return the number of active images
		this.count_images = () => {
			var count = 0;
			this.state.images.map( item => {
				if (item.deleted == 0) count++;
			});

			return count;
		}


		this.new_image = event => {
			event.preventDefault();

			if (this.count_images() >= this.state.max_image_limit) {
				error_message("Έχετε φτάσει στο επιτρεπτό όριο φωτογραφιών!");
			} else {
				$("#imageUploadInput").click();
			}
		}


		this.delete_image = event => {
			event.preventDefault();
			if (window.confirm("Να διαγραφεί η εικόνα με αριθμό " + (event.item.index + 1) + " από την αγγελία;")) {
				//arr = arr.filter(item => item !== value)

				// Add image in removed images
				if (event.item.image.id > 0) {
					//this.state.removed.push({ id: event.item.image.id });
					event.item.image.deleted = 1;
					this.opts.onchangehandler();
				} else {
					// Remove image from "upload" folder
					var tag = this;
					request('image_remove',
						{
							image: event.item.image.media,
							path: event.item.image.path,
						},
						function(result) {

							tag.state.images.splice(event.item.index, 1);
							tag.update();
							tag.opts.onchangehandler();

						}, null, this.toggle_loader
					);
				}
			}
		}


		this.init_images = () => {
			this.state.images.map( item => {
				item.deleted = 0;
			});
		}


		this.get_max_view_index = () => {
			var view_index = 0;
			this.state.images.map( item => {
				if (view_index <= item.view_index) {
					view_index = item.view_index;
				}
			});
			return view_index + 1;
		}


		/* Image upload handlers */

		this.upload = {
			files: null,
			file_index: 0,
			files_max: 0,
			progress: 0,
		}

		this.reset_upload = () => {
			$('#imageUploadForm').trigger('reset');
			this.upload.files = null;
			this.upload.file_index = 0;
			this.upload.files_max = 0;
			this.update();
		}

		this.imageUploadInput_change = event => {
			event.preventDefault();

			// Check if correct file types and file sizes
			this.upload.files = $('#imageUploadForm').find('#imageUploadInput')[0].files;

			//console.log("imageUploadInput_change");
			//console.log(this.count_images(), this.upload.files.length, this.state.max_image_limit);

			if (this.upload.files.length + this.count_images() > this.state.max_image_limit) {
				error_message("Οι φωτογραφίες που επιλέξατε ξεπερνούν το επιτρεπτό όριο για αυτή την αγγελία!");
				this.reset_upload();
				return false;
			} else {
				var validFileType = true;
				var totalFileSize = 0;
				var index;

				for (index=0; index<this.upload.files.length; index++) {

					//console.log("Check file type");
					//console.log(this.upload.files[index]);
					//console.log(this.upload.files[index].type);

					totalFileSize+= this.upload.files[index].size;
					if (this.upload.files[index].type != 'image/jpeg' && this.upload.files[index].type != 'image/png') {
						error_message("Επιτρέπονται μόνο εικόνες τύπου .jpg, .jpeg ή .png!");
						this.reset_upload();
						return false;
					}
				}

				$("#imageUploadForm").submit();
			}
		}


		this.imageUploadForm_submit = event => {
			event.preventDefault();

			this.upload.file_index = 0;
			this.upload.files_max = this.upload.files.length;
			this.uploadNextImage();
		}


		this.uploadNextImage = () => {
			this.upload.progress = 0;
			this.update();

			if (this.upload.file_index < this.upload.files_max) {

				var formData = new FormData();
				formData.append('object', 'ad');
				formData.append('image', this.upload.files[this.upload.file_index]);

				var tag = this;
				$.ajax({
					url: "/app/php/image_upload.php",
					type:'POST',
					data: formData,
					dataType:'json',
					contentType: false,
					processData: false,
					xhr: function() {
						var xhr = $.ajaxSettings.xhr();
						if(xhr.upload){ 
							xhr.upload.addEventListener('progress', tag.upload_progress, false);
						}
						return xhr;
					},
					success: function(result) {
						if (result.error) {
							error_message(result.error);
						} else {
							// get maximum view_index from image
							var view_index = tag.get_max_view_index();
							// Add image in state images
							tag.state.images.push({ id:0, media:result.filename, path:result.path, view_index:view_index, deleted: 0 });
							tag.update();
							tag.opts.onchangehandler();
						}

						setTimeout(function() {
							tag.upload.file_index++;
							tag.update();
							tag.uploadNextImage();
						}, 2000);

					},
					error: function(result) {
						console.log("UPLOAD ERROR!");
						console.log(result);
						if (result.status) {
							error_message(result.responseText);
						}

						tag.reset_upload();
					}
				});

			} else {
				this.reset_upload();
        	}
		}

		this.upload_progress = event => {
		    if(event.lengthComputable){
		        this.upload.progress = Math.round((event.loaded * 100) / event.total);
		    }
		    this.update();
		}


		this.on("mount", function() {
			var tag = this;

			$('#ad-photos').sortable({
				tolerance: 'pointer',
				stop: function( event, ui ) {

					console.log()

					// Set photos view index
					$('#ad-photos .image-item').each(function(index, item) {
						console.log('index: ' + index);
						console.log('data-index: ' + $(item).attr("data-index"));

						var item_index = $(item).attr("data-index");
						var image = tag.state.images[item_index];
						if (image) {
							image.view_index = index;
						}
					});

					tag.opts.onchangehandler();
				}
			});

			// Image upload form handlers
			$('#imageUploadInput').bind("change", this.imageUploadInput_change); //Product.imageUploadHandler
			$('#imageUploadForm').bind("submit", this.imageUploadForm_submit); // Product.imageUploadFormHandler
		})

	</script>
</control-ad-photos>